
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2015 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title PUSH

@desc Push Multiple Registers stores multiple registers to the stack, storing to consecutive memory locations ending just below the address in SP, and updates SP to point to the start of the stored data.

@encoding (t1) {

	@half 1 0 1 1 0 1 0 M(1) register_list(8)

	@syntax <registers>

	@conv {

		registers = RegistersList('0':M:'000000':register_list)

	}

}

@encoding (T2) {

	@word 1 1 1 0 1 0 0 1 0 0 1 0 1 1 0 1 0 M(1) 0 register_list(13)

	@syntax ".W" <registers>

	@conv {

		registers = RegistersList('0':M:'0':register_list)

	}

}

@encoding (T3) {

	@word 1 1 1 1 1 0 0 0 0 1 0 0 1 1 0 1 Rt(4) 1 1 0 1 0 0 0 0 0 1 0 0

	@syntax ".W" <registers>

	@conv {

		registers = Zeros(16)

	}

}

@encoding (A1) {

	@word cond(4) 1 0 0 1 0 0 1 0 1 1 0 1 register_list(16)

	@syntax <registers>

	@conv {

		registers = RegistersList(register_list)

	}

	@rules {

		chk_call StoreCondition(cond)

	}

}

@encoding (A2) {

	@word cond(4) 0 1 0 1 0 0 1 0 1 1 0 1 Rt(4) 0 0 0 0 0 0 0 0 0 1 0 0

	@syntax <registers>

	@conv {

		registers = Zeros(16)

	}

	@rules {

		chk_call StoreCondition(cond)

	}

}

